/*---------------------------------------------------------------------------------------------
		File: userFormat.r
		
		 Electronic Arts 1993
		
		This file contains the type definition for custom format resources used in EADebug

---------------------------------------------------------------------------------------------*/
/* User format resourse type definition */

#ifndef __UserFmt__
#define __UserFmt__

#define UFMTVersion 0

/* flags bits */
#define NewLine	1 /* generate a new line after this field */
#define ZeroIsMost 2 /* bit offset 0 is most significant bit */
#define NoValue 4 /* no value displayed. pure text */

type 'UFMT' {
	integer = UFMTVersion;					/* Version number */
	integer;								/* input type size */
	integer = $$CountOf(field);				/* # of fields, at least 1 */
	wide array field {
		longint;							/* offset (bytes if >=0, bits if <0) */
		longint;							/* width (bytes if >=0, bits if <0) */
		integer								/* display type */
				Decimal,
				Hex,
				Char,
				CString,
				PString,
				Frac16_16,
				UFrac16_16,
				Frac12_20,
				UFrac12_20,
				On_Off,
				True_False,
				SDecimal,
				UDecimal;
		unsigned longint;					/* flags (newline,...) */
		unsigned longint = 0;				/* reserved */
		pstring;							/* field name */
		align word;
	};
};

#endif

