
/******************************************************************************************************************/
#ifdef ENABLE_TESTS
#ifdef ENABLE_OpenAVFolio_TESTS
	/* 	------------------------------------------------------------------------------------------
		TEST: 		Exercise avOpenStreamFile()
		TYPE:		BAT / FT / EST / DT / LST
		------------------------------------------------------------------------------------------	*/
		{
			int32		p[10];
			Item		fileItem, stream;
			int32		closeItem, iii;
			Boolean		normalAbilities[16];
			uint32		normalTags[16], theTagFound;
			Boolean		foundTag, foundCorrectValue;
			Err 		TheErr;
			
			gProgName 	= "AVtest.c";
			gTestName 	= "OpenAVFolio";
			gTestLevel 	= DEPTH;
			gTestType 	= AUTOMATED;
			
			BlockEnter();
			SetPassed();
#ifdef ENABLE_BAT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_FT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_EST_TESTS
			#include "DepthTest_TopPortion.h"
			// Do it several times
			for (iii=0;iii<10;iii++)
			{
				if ((TheErr = OpenAVFolio()) < 0)
				{
					PrintfSysErr(TheErr);
					SetTestResult( FAILED, "EST - OpenAVFolio() cannot be called repetetively - returned %x on iteration %x\n", TheErr, iii );
				}
			}
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_DT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_LST_TESTS
			#include "DepthTest_TopPortion.h"
			// Do it several times
			for (iii=0;iii<10;iii++)
			{
				if ((TheErr = OpenAVFolio()) < 0)
				{
					PrintfSysErr(TheErr);
					SetTestResult( FAILED, "LST - OpenAVFolio() cannot be called repetetively - returned %x on iteration %x\n", TheErr, iii );
				}
			}
			#include "DepthTest_BottomPortion.h"
#endif
			BlockExit();
		}

	/*	------------------------------------------------------------------------------------------	*/
#endif	/* ENABLE_OpenAVFolio_TESTS */
#endif	/* ENABLE_TESTS */
/******************************************************************************************************************/

