
/******************************************************************************************************************/
#ifdef ENABLE_TESTS
#ifdef ENABLE_avGetStreamPosition_TESTS
	/* 	------------------------------------------------------------------------------------------
		TEST: 		Exercise avGetStreamPosition()
		TYPE:		BAT / FT / EST / DT / LST
		------------------------------------------------------------------------------------------	*/
		{
			#include ":DATA:DepthTest_avGetStreamPosition.h"
			int32		p[10];
			Item		fileItem, stream;
			int32		closeItem;
	static	Boolean		normalAbilities[16];
			uint32		normalTags[16], theTagFound;
			Boolean		foundTag, foundCorrectValue;
			Err			TheErr;
	static	TagArg 		TheInfoArray[] =	{
												{AV_TAG_GSP_FIELDS , &normalAbilities[0]},
												{AV_TAG_GSP_ABSTIME , &normalAbilities[1]},
												{AV_TAG_GSP_BYTES , &normalAbilities[2]},
												{AV_TAG_GSP_BLOCKS , &normalAbilities[3]},
												{TAG_END},
											};
			
			gProgName 	= "AVtest.c";
			gTestName 	= "avGetStreamPosition";
			gTestLevel 	= DEPTH;
			gTestType 	= AUTOMATED;
			
			BlockEnter();
			SetPassed();
#ifdef ENABLE_BAT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_FT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_EST_TESTS
			#include "DepthTest_TopPortion.h"
			TheErr = avGetStreamPosition( ARGUMENT_01, TheInfoArray );
			if (TheErr >= 0)
			{
				SetTestResult( FAILED, "EST - avGetStreamPosition( %x, TheInfoArray ) did not detect the erroneous streamer id - returned %x\n", ARGUMENT_01, TheErr );
			}
			TheErr = avGetStreamPosition( streamer, ARGUMENT_02 );
			if (TheErr >= 0)
			{
				SetTestResult( FAILED, "EST - avGetStreamPosition( streamer, %x ) did not detect the erroneous TagArg array - returned %x\n", ARGUMENT_02, TheErr );
			}
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_DT_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
#ifdef ENABLE_LST_TESTS
			#include "DepthTest_TopPortion.h"
			#include "DepthTest_BottomPortion.h"
#endif
			BlockExit();
		}

	/*	------------------------------------------------------------------------------------------	*/
#endif	/* ENABLE_avGetStreamPosition_TESTS */
#endif	/* ENABLE_TESTS */
/******************************************************************************************************************/

