 
/*
	File:		baseUtils.c

	Contains:	Base utilities for folio call tests

	Written by:	Robert Chinn, Charlie Eckhaus

	Copyright:	 1993 by The 3DO Company. All rights reserved.
				This material constitutes confidential and proprietary
				information of the 3DO Company and shall not be used by
				any Person or for any purpose except as expressly
				authorized in writing by the 3DO Company.

	Change History (most recent first):

		 <3>	 7/22/93	CDE		Added isNumber, HexToInt32, isHexNumber, GetNextNumParam,
		 							GetNextHexParam
									Changed GetFlag to GetNextFlagParam
		 <2>	 6/29/93	CDE		General fixup per Robert (new comments, deletion of unused code)
		 							Added gInvalidArg, command line argument validation
		 <1>	 6/22/93	CDE		Prepared for public consumption

	To Do:
*/

#include "baseUtils.h"
#include "stdio.h"

long	power(long x, long y)
/* Return x to the yth power */
{
	 long i, p;
	 
	 p = 1;
	 for ( i = 1; i <= y; ++i)
	 	p = p * x;
		
	return p;
}


void 	printd(int32 n, FILE *theFile)
/* Used by pipedata to output decimal values to the log file */
{
/*
	if (n/10)
		printd(n/10,theFile);
	 putc((char) n%10 + '0',theFile);
*/
	char aString[64];
	
	sprintf(aString,"%i",n);
	fputs(aString,theFile);
}

void 	printHex(int32 n, FILE *theFile)
/* Used by pipedata to output hex values to the log file */
{
	long	indx;
	char	*hexChar[] = {	"0","1","2","3","4",
							"5","6","7","8","9",
							"a","b","c","d","e","f" };
	
	for (indx = 7; indx >= 0; indx--)
	{
		fputs( hexChar[((n) >> indx * 4) & 0xF], theFile);	
	}
}


Item	GetMyItem(void)
/* Get the item corresponding to the current task */
{
	return KernelBase->kb_CurrentTask->t.n_Item;
}

int32 SecondsToAudioTicks( int32 Secs )
/* Convert the specified number of seconds to ticks */
/* NOTE: You must open the audio folio to use this! */
{
	frac16 Rate;
	
	Rate = GetAudioRate() >> 16;
	return ( Secs * Rate );
}

int32 SleepSeconds( int32 Secs )
/* Sleep the specified number of seconds */
/* NOTE: You must open the audio folio to use this! */
{
	return SleepAudioTicks ( SecondsToAudioTicks( Secs ) );
}

