
/******************************************************************************************************************/
#ifdef ENABLE_TESTS
#ifdef ENABLE_avGetStreamer_TESTS
	/* 	------------------------------------------------------------------------------------------
		~#$
		TEST: 		Exercise avGetStreamer()
		TYPE:		API - FUNCTIONAL / API - BOUNDARY / API - ERROR
		METHOD:		1. Depth test: Long & short strings, literal & indirect filenames
					2. Invalid test: strings with embedded pathnames, get non-streamer file
		------------------------------------------------------------------------------------------	*/
		{
			#include ":DATA:DepthTest_avGetStreamer.h"
			int32		p[10];
			Item		fileItem;
			int32		closeItem;
			
			gProgName 	= "AVtest.c";
			gTestName 	= "avGetStreamer";
			gTestLevel 	= DEPTH;
			gTestType 	= AUTOMATED;
			
			BlockEnter();
			SetPassed();
#ifdef ENABLE_FT_TESTS
			#include "DepthTest_TopPortion.h"
			streamer = avGetStreamer(ARGUMENT_01);
			if( streamer < 0 )
			{ 
				SetTestResult( FAILED, "FT - avGetStreamer( %s ) returned %x\n", ARGUMENT_01, closeItem);
			}
			else
			{
				avRemoveStreamer( streamer );
			};
			#include "DepthTest_BottomPortion.h"
cleanup1:
			closeItem = 0;
#endif
#ifdef ENABLE_EST_TESTS
			#include "DepthTest_TopPortion.h"
			streamer = avGetStreamer(ARGUMENT_02);
			if( streamer >= 0 )
			{ 
				SetTestResult( FAILED, "EST - avGetStreamer( %s ) returned %x\n", ARGUMENT_02, closeItem);
				avRemoveStreamer( streamer );
			};
			#include "DepthTest_BottomPortion.h"
cleanup2:
			closeItem = 0;
#endif
			BlockExit();
		}

	/*	------------------------------------------------------------------------------------------	*/
#endif	/* ENABLE_avGetStreamer_TESTS */
#endif	/* ENABLE_TESTS */
/******************************************************************************************************************/

