	print_vinfo();								// Print out the version string

	if ((argc == 2) && (*argv[1] == '?'))
	{
		Usage();
		return(0);
	}

	filename = "1";

// 	------------------------------------------------------------------------------------------
//																			OpenAVfolio tests
#include "AVtest_OpenAVfolio.c"
//
// 	------------------------------------------------------------------------------------------

	if ((err = OpenAVFolio()) < 0)
	{
		PrintfSysErr(err);
		exit(err);
	}

	if ((err = OpenGraphicsFolio()) < 0)
	{
		CloseAVFolio();
		PrintfSysErr(err);
		exit(err);
	}

	vbl = GetVBLIOReq();

	/* Attempt to read the STT file. If this is not possible, then the default
	 * values as set above will be used (and these are set up for my
	 * configuration).
	 * These config values can be overriden from the shell using the appropriate
	 * command line parameters.
	 */
	fp = OpenDiskStream(STT_FILENAME, 0);
	if (fp)
	{
		strcpy(sttiis, parse_file(fp));
		iisIP = sttiis;
		strcpy(sttServer, parse_file(fp));
		serverIP = sttServer;
		strcpy(client, parse_file(fp));
		clientIP = client;
		port = strtoul(parse_file(fp), NULL, 10);
		printf("From stt.config:\n");
		printf("iis = %s\n", iisIP);
		printf("server = %s\n", serverIP);
		printf("client = 0x%lx\n", clientIP);
		printf("port = %ld\n", port);
		CloseDiskStream(fp);
	}
	else
	{
		printf("Error opening %s\n", STT_FILENAME);
	}

	/* Parse the command line */

	while ((i = getopt(argc, argv, "n:f:d:t:sr:c:i:p:vRUab:")) != -1) {
		switch (i) {
		case 'n':
		  /* Hmm. This looks like old code left over from the WhiteBookCD
		   * test code, where I am trying to build a filename of the 
		   * form "track8".
		   */
		  track = atoi(optarg); 
		  strcat(filenameBuild, "track");
		  strcat(filenameBuild, optarg);
		  filename = filenameBuild;
		  break;
		case 'f':
		  /* -f. This is the filename to use. */
		  filename = optarg;
		  /* use this streamer */
		  streamerName = "avMPEGStreamer";
		  break;
		case 'd':
		  depth = atoi(optarg);
		  if( depth != 16 && depth != 24 ) {
		    printf("ERROR:  depth must be either 16 or 24\n");
		    Usage();
		  }
		  break;
		case 't':
		  /* -t. Give the name of the streamer */
		  streamerName = optarg;
		  printf("Using streamer %s\n", streamerName);
		  break;
		case 's':
		  /* -s. I'm going to allocate the screen for the streamer to use
		   * rather than have the streamer allocate its own.
		   */
		  allocateScreen = TRUE;
		  break;
		case 'r':
		  /* -r. Override the serverIP */
		  serverIP = optarg;
		  kprintf("server IP = %s\n", serverIP);
		  break;
		case 'c':
		  /* -c. Override the clientIP (STT) */
		  clientIP = optarg;
		  kprintf("client IP = %s\n", clientIP);
		  break;
		case 'i':
		  /* -i. Override the IISIP */
		  iisIP = optarg;
		  kprintf("iis IP = %s\n", iisIP);
		  break;
		case 'p':
		  /* -p. Override the port number */
		  port = atoi(optarg);
		  kprintf("port = %ld\n", port);
		  break;
		case 'v':
		  /* -v. Force DMA, don't use Slipstream. Must be used if running
		   * on a MIA 1 card.
		   */
		  forceDMA = TRUE;
		  break;
		case 'R':
		  /* -R. Disable RPCs */
		  useRPC = FALSE;
		  useCAM = FALSE;
		  filename = "1-";	/* Temporary kludge. Name starts with a digit
					 * for network use, '-' to disable RPCs in the
					 * streamer.
					 */
		break;
		case 'U':
		  /* -U. Disable User feedback */
		  userFeedback = FALSE;
		  break;
		case 'a':
		  /* -a, Use CAM folio */
		  useCAM = TRUE;
		  useRPC = FALSE;
		  break;
		case 'b':
		  /* -b, service ID */
		  svc_id = atoi(optarg);
		  break;
		default:
		  Usage();
		}
	}
