//  
//  
//  

#define kBufferCount 2

#ifndef FAILOSERR
#	define FAILOSERR( name, result )			\
		if ( ((long) result) < 0 )				\
			{ 									\
			printf( "Failure in %s: %d ($%x)\n", name, ((long) result), ((long) result) ); \
			PrintfSysErr( result );				\
			exit( 0 );							\
			}
#endif



Item 			gTEAmsg;
Global 			*gMyGlobal;
Boolean 		gMovieStarted = false;
ScreenContext	gScreenContext;
ubyte		  	*gBackPic[kBufferCount];		// background image buffers
TEA_Thread		gThreadInfo;
int32			gCurrentEffect = 0;
int32			gEffectCnt = 0;

// 
// 
typedef struct
{
	DoTEAProc EffectProcPtr;
	char *EffectName;
} EffectInfo;


// 
// 
EffectInfo EffectProcs[] =
{
	TEA_Dissolve, "TEA_Dissolve",

	PinWheel_PullOff, "PinWheel_PullOff",
	PinWheel_PushOn, "PinWheel_PushOn",
	
Stretch_PushOff_Up, "Stretch_PushOff_Up",
Stretch_PushOff_Down, "Stretch_PushOff_Down",
Stretch_PushOff_Left, "Stretch_PushOff_Left",
Stretch_PushOff_Right, "Stretch_PushOff_Right",
Stretch_PushOff_Vert, "Stretch_PushOff_Vert",
Stretch_PushOff_Horiz, "Stretch_PushOff_Horiz",

	PagePeel_PullOff, "PagePeel_PullOff",
	PagePeel_PushOn, "PagePeel_PushOn",
	
	Wipe_Up, "Wipe_Up",
	Wipe_Left, "Wipe_Left",
	Wipe_Right, "Wipe_Right",
	Wipe_Down, "Wipe_Down",
PageTurn_PushOn_TopLeft, "PageTurn_PushOn_TopLeft",
PageTurn_PushOn_BottomRight, "PageTurn_PushOn_BottomRight",
	Wipe_TopLeft, "Wipe_TopLeft",
	Wipe_TopRight, "Wipe_TopRight",
	Wipe_BottomLeft, "Wipe_BottomLeft",
	Wipe_BottomRight, "Wipe_BottomRight",

Spin_PullOff, "Spin_PullOff",
Spin_PushOn, "Spin_PushOn",

BandSlide_PushOff_Left, "BandSlide_PushOff_Left",
BandSlide_PushOff_Up, "BandSlide_PushOff_Up",
BandSlide_PushOff_Right, "BandSlide_PushOff_Right",
BandSlide_PushOff_Down, "BandSlide_PushOff_Down",

	CardFlip_PullOff_Left, "CardFlip_PullOff_Left",
	CardFlip_PullOff_Right, "CardFlip_PullOff_Right",

Stretch_PullOff_Up, "Stretch_PullOff_Up",
Stretch_PullOff_Down, "Stretch_PullOff_Down",

BandSlide_PushOn_Left, "BandSlide_PushOn_Left",
BandSlide_PushOn_Up, "BandSlide_PushOn_Up",
BandSlide_PushOn_Right, "BandSlide_PushOn_Right",
BandSlide_PushOn_Down, "BandSlide_PushOn_Down",

	PageTurn_PullOff_BottomRight, "PageTurn_PullOff_BottomRight",
	PageTurn_PullOff_TopLeft, "PageTurn_PullOff_TopLeft",

Strip_PullOff_Down_Left, "Strip_PullOff_Down_Left",
Strip_PullOff_Down_Right, "Strip_PullOff_Down_Right",
Strip_PullOff_Right_Up, "Strip_PullOff_Right_Up",
Strip_PullOff_Right_Down, "Strip_PullOff_Right_Down",

	PullOff_Up, "PullOff_Up",
	PullOff_Down, "PullOff_Down",
	PullOff_Left, "PullOff_Left",
	PullOff_Right, "PullOff_Right",

PageTurn_PushOn_TopRight, "PageTurn_PushOn_TopRight",
PageTurn_PushOn_BottomLeft, "PageTurn_PushOn_BottomLeft",

BandSlide_PullOff_Left, "BandSlide_PullOff_Left",
BandSlide_PullOff_Up, "BandSlide_PullOff_Up",
BandSlide_PullOff_Right, "BandSlide_PullOff_Right",
BandSlide_PullOff_Down, "BandSlide_PullOff_Down",

Split_PullOff_Horiz, "Split_PullOff_Horiz",
Split_PushOn_Horiz, "Split_PushOn_Horiz",

	PullOff_TopLeft, "PullOff_TopLeft",
	PullOff_TopRight, "PullOff_TopRight",
	PullOff_BottomLeft, "PullOff_BottomLeft",
	PullOff_BottomRight, "PullOff_BottomRight",

	CardFlip_PullOff_Up, "CardFlip_PullOff_Up",
	CardFlip_PullOff_Down, "CardFlip_PullOff_Down",

	PushOff_Up, "PushOff_Up",
	PushOff_Down, "PushOff_Down",
	PushOff_Left, "PushOff_Left",
	PushOff_Right, "PushOff_Right",
	
Swap_PushOn__Left, "Swap_PushOn__Left",
Swap_PushOn__Right, "Swap_PushOn__Right",

	PushOff_TopLeft, "PushOff_TopLeft",
	PushOff_TopRight, "PushOff_TopRight",
	PushOff_BottomLeft, "PushOff_BottomLeft",
	PushOff_BottomRight, "PushOff_BottomRight",

	Stretch_PushOn_Vert, "Stretch_PushOn_Vert",
	Stretch_PushOn_Horiz, "Stretch_PushOn_Horiz",

Stretch_PullOff_Left, "Stretch_PullOff_Left",
Stretch_PullOff_Right, "Stretch_PullOff_Right",

	PushOn_Up, "PushOn_Up",
	PushOn_Down, "PushOn_Down",
	PushOn_Left, "PushOn_Left",
	PushOn_Right, "PushOn_Right",

Strip_PushOn_Left_Up, "Strip_PushOn_Left_Up",
Strip_PushOn_Left_Down, "Strip_PushOn_Left_Down",
Strip_PushOn_Up_Left, "Strip_PushOn_Up_Left",
Strip_PushOn_Up_Right, "Strip_PushOn_Up_Right",

Split_PullOff_Vert, "Split_PullOff_Vert",
Split_PushOn_Vert, "Split_PushOn_Vert",

	PushOn_TopLeft, "PushOn_TopLeft",
	PushOn_TopRight, "PushOn_TopRight",
	PushOn_BottomLeft, "PushOn_BottomLeft",
	PushOn_BottomRight, "PushOn_BottomRight",

Random_PushOn_Horiz, "Random_PushOn_Horiz",
Random_PushOn_Vert, "Random_PushOn_Vert",

	Stretch_PullOff_Vert, "Stretch_PullOff_Vert",
	Stretch_PullOff_Horiz, "Stretch_PullOff_Horiz",
	
Zoom_PullOff, "Zoom_PullOff",
Zoom_PushOn, "Zoom_PushOn",

Strip_PullOff_Left_Up, "Strip_PullOff_Left_Up",
Strip_PullOff_Left_Down, "Strip_PullOff_Left_Down",
Strip_PullOff_Up_Left, "Strip_PullOff_Up_Left",
Strip_PullOff_Down_Right, "Strip_PullOff_Down_Right",

Shutter_PullOff_Vert, "Shutter_PullOff_Vert",
Shutter_PushOn_Vert, "Shutter_PushOn_Vert",

Stretch_PushOn_Up, "Stretch_PushOn_Up",
Stretch_PushOn_Down, "Stretch_PushOn_Down",

Strip_PushOff_Left_Up, "Strip_PushOff_Left_Up",
Strip_PushOff_Left_Down, "Strip_PushOff_Left_Down",
Strip_PushOff_Up_Left, "Strip_PushOff_Up_Left",
Strip_PushOff_Up_Right, "Strip_PushOff_Up_Right",

FourCornerSplit_PullOff, "FourCornerSplit_PullOff",
FourCornerSplit_PushOn, "FourCornerSplit_PushOn",

Swap_PushOn__Up, "Swap_PushOn_Up",
Swap_PushOn__Down, "Swap_PushOn_Down",

Stretch_PushOn_Left, "Stretch_PushOn_Left",
Stretch_PushOn_Right, "Stretch_PushOn_Right",

Strip_PushOff_Down_Left, "Strip_PushOff_Down_Left",
Strip_PushOff_Down_Right, "Strip_PushOff_Down_Right",
Strip_PushOff_Right_Up, "Strip_PushOff_Right_Up",
Strip_PushOff_Right_Down, "Strip_PushOff_Right_Down",

FourCornerWipe_PullOff, "FourCornerWipe_PullOff",
FourCornerWipe_PushOn, "FourCornerWipe_PushOn",

Shutter_PullOff_Horiz, "Shutter_PullOff_Horiz",
Shutter_PushOn_Horiz, "Shutter_PushOn_Horiz",

	PageTurn_PullOff_TopRight, "PageTurn_PullOff_TopRight",
	PageTurn_PullOff_BottomLeft, "PageTurn_PullOff_BottomLeft",


	TEA_FadeToBlack, "TEA_FadeToBlack",

Strip_PushOn_Down_Left, "Strip_PushOn_Down_Left",
Strip_PushOn_Down_Right, "Strip_PushOn_Down_Right",
Strip_PushOn_Right_Up, "Strip_PushOn_Right_Up",
Strip_PushOn_Right_Down, "Strip_PushOn_Right_Down",


};




// 
// 
void CopyData(TEA_Phase phase, void *aVoidTEA)
{
	TEA_Environment *anENV;

	anENV = (TEA_Environment *) aVoidTEA;
	
	switch (phase)
	{
		case TEA_POST_CELDRAW 	: if (anENV->signal->MessageBits & TEA_BUFFERS_SWAPPPED)
									  memcpy(anENV->BufferB_SourcePtr, gMyGlobal->myCCB.ccb_SourcePtr, gScreenContext.sc_nFrameByteCount);
								  else memcpy(anENV->BufferA_SourcePtr, gMyGlobal->myCCB.ccb_SourcePtr, gScreenContext.sc_nFrameByteCount);
	}
	
}

// 
// InitTEA
// 
Boolean InitTEA(Global *glob)
{
	Item  aVRAMIOReq;
	int32 x;
	
	gMyGlobal = glob;
	
	aVRAMIOReq = GetVRAMIOReq();
   if (aVRAMIOReq < 0)
   {
      DIAGNOSTIC("Error getting VRAM transfer IO request\n");
	   return false;
   }

	if (!OpenSPORT())
	{
		DIAGNOSTIC("Can't open SPORT I/O!");
		return FALSE;
	}

	if (OpenMathFolio() < 0)
	{
		DIAGNOSTIC("Cannot open MathFolio");
		return FALSE;
	}

	if ( InitEventUtility(1, 0, 1) < 0)
	{
		DIAGNOSTIC("Cannot open graphics");
		return FALSE;
	}

	if (!OpenGraphics(&gScreenContext,2))
	{
		DIAGNOSTIC("Can't open the graphics folio!");
		return FALSE;
	}

	gCurrentEffect = 0;
	
	gScreenContext.sc_nScreens 	= 2;
	gScreenContext.sc_curScreen	= 0;
	gScreenContext.sc_Screens[0] = gMyGlobal->screensI[0];
	gScreenContext.sc_Screens[1] = gMyGlobal->screensI[1];
	gScreenContext.sc_BitmapItems[0] = gMyGlobal->vBitmapsI[0];
	gScreenContext.sc_BitmapItems[1] = gMyGlobal->vBitmapsI[1];
	gScreenContext.sc_Bitmaps[0] = gMyGlobal->vBitmaps[0];
	gScreenContext.sc_Bitmaps[1] = gMyGlobal->vBitmaps[1];
	
	gScreenContext.sc_nFrameBufferPages = (gScreenContext.sc_Bitmaps[0]->bm_Width * 2 * gScreenContext.sc_Bitmaps[0]->bm_Height
			+ GrafBase->gf_VRAMPageSize-1) 
			/ GrafBase->gf_VRAMPageSize;
			
	gScreenContext.sc_nFrameByteCount = gScreenContext.sc_nFrameBufferPages * GrafBase->gf_VRAMPageSize;

	// now allocate some memory for the images buffers
	for ( x = 0; x < kBufferCount; x++ )
	{
		gBackPic[x] = (ubyte *) ALLOCMEM( 
													(int32) gScreenContext.sc_nFrameByteCount, 
													GETBANKBITS(GrafBase->gf_ZeroPage) | MEMTYPE_STARTPAGE | MEMTYPE_VRAM | MEMTYPE_CEL
												  );
	
		if ( gBackPic[x] == NULL )
		{
			DIAGNOSTIC ("unable to allocate gBackPic");
			return false;
		}
		
		// initialize it to black
		SetVRAMPages( aVRAMIOReq, gBackPic[x], 0, gScreenContext.sc_nFrameBufferPages, 0xFFFFFFFF);
	}

	TEA_OpenThruScreenContext(&gScreenContext);
	TEA_SetGlobalBuffers(gBackPic[0], gBackPic[1]);

	return true;
}
