
/******************************************************************************************************************/
#ifdef ENABLE_TESTS
#ifdef ENABLE_avGetStreamerAbilities_TESTS
	/* 	------------------------------------------------------------------------------------------
		TEST: 		Exercise avGetStreamerAbilities()
		TYPE:		BAT / FT / EST / DT / LST
		------------------------------------------------------------------------------------------	*/
		{
			#include ":DATA:DepthTest_avGetStreamerAbilit.h"
			int32		p[10];
			Item		fileItem;
			int32		closeItem;
			Boolean		normalAbilities[16];
			uint32		normalTags[16],theTagFound;
			Boolean		foundTag, foundCorrectValue;
			
			gProgName 	= "AVtest.c";
			gTestName 	= "avGetStreamerAbilities";
			gTestLevel 	= DEPTH;
			gTestType 	= AUTOMATED;
			
			BlockEnter();
			SetPassed();
#ifdef ENABLE_FT_TESTS
			#include "DepthTest_TopPortion.h"
			for (i = 0; i < ((sizeof(getAbilities) / sizeof(TagArg)) - 1); i++)
			{
				getAbilities[i].ta_Arg = (void *)&abilities[i];
			}
			/* first get a normal to test against	*/
			avGetStreamerAbilities(streamer, getAbilities);
			#include "DepthTest_BottomPortion.h"
cleanup3:
			closeItem = 0;
#endif
#ifdef ENABLE_EST_TESTS
			for (i = 0; i < ((sizeof(getAbilities) / sizeof(TagArg)) - 1); i++)
			{
				getAbilities[i].ta_Arg = (void *)&abilities[i];
			}
			/* first get a normal to test against	*/
			avGetStreamerAbilities(streamer, getAbilities);
			for (i = 0; i < (sizeof(getAbilities) / sizeof(TagArg)); i++)
			{
				normalAbilities[i] = abilities[i];
				normalTags[i] = getAbilities[i].ta_Tag;
			}
			#include "DepthTest_TopPortion.h"
			avGetStreamerAbilities( ARGUMENT_01, getAbilities);
			for (i = 0; i < (sizeof(getAbilities) / sizeof(TagArg)); i++)
			{
				if( normalAbilities[i] != abilities[i] )
				{
					goto cleanup4;
				}
			}
			#include "DepthTest_BottomPortion.h"
			
			/* If we get to this point, avGetStreamerAbilities() does'nt check its 1st argument */
			SetTestResult( FAILED, "avGetStreamerAbilities( <invalidStreamer>, getAbilities[] ) did not detect the <invalidStreamer> argument\n" );
cleanup4:			
			closeItem = 0;
			
			/* A little assurance test before the automated part of Invalid testing */
			for (i = 0; i < ((sizeof(getAbilities) / sizeof(TagArg)) - 1); i++)
			{
				getAbilities[i].ta_Arg = (void *)&abilities[i];
				getAbilities[i].ta_Tag = AV_TAG_ABLE_PLAY;
			}
			avGetStreamerAbilities( streamer, getAbilities );
			for (i = 0; i < ((sizeof(getAbilities) / sizeof(TagArg)) - 1); i++)
			{
				if( abilities[i] != abilities[0] )
				{
					SetTestResult( FAILED, "avGetStreamerAbilities( multiple AV_TAG_ABLE_PLAYs ) returned garbage\n" );
					goto cleanup5;
				}
			}
		
			#include "DepthTest_TopPortion.h"
			avGetStreamerAbilities( streamer, ARGUMENT_02 );
			i = 0;
			foundTag = TRUE;
			foundCorrectValue = TRUE;
			theTagFound = 0;
			while( (ARGUMENT_02)[i].ta_Tag != TAG_END )
			{
				for( j=0; j<(sizeof(normalAbilities) / sizeof(Boolean)); j++ )
				{
					if( normalTags[j] == (ARGUMENT_02)[i].ta_Tag )
					{
						if( normalAbilities[j] != ArrayAbilities[i] )
						{
							SetTestResult( FAILED, "avGetStreamerAbilities(id,<badArray>) returned the wrong value for what it thought was a valid TagArg - PARAM_02[(%x)]\n", p[2] );
							foundCorrectValue = FALSE;
							goto cleanup5a;
						}
						theTagFound++;
					}
				}
				if( (j >=  (sizeof(normalAbilities))) && (theTagFound<(sizeof(normalAbilities) / sizeof(Boolean))) )
				{
					/* did not find a matching tag_arg */
					foundTag = FALSE;
					goto cleanup5a;
				}
				i++;
			}
cleanup5a:
			if( (foundTag) && (foundCorrectValue) )
			{
				SetTestResult( FAILED, "avGetStreamerAbilities( id, <badArray> ) did not detect the <badArray>\n" );
			}

			#include "DepthTest_BottomPortion.h"
cleanup5:
			closeItem = 0;
#endif
			BlockExit();
		}

	/*	------------------------------------------------------------------------------------------	*/
#endif	/* ENABLE_avGetStreamerAbilities_TESTS */
#endif	/* ENABLE_TESTS */
/******************************************************************************************************************/

