#
#	File:		bounce.make
#
#	Contains:	make file for building Bounce.
#
#	Written by:	Joe Buczek
#
#	Copyright:	 1993 by The 3DO Company. All rights reserved.
#				This material constitutes confidential and proprietary
#				information of the 3DO Company and shall not be used by
#				any Person or for any purpose except as expressly
#				authorized in writing by the 3DO Company.
#
#	Change History (most recent first):
#
#		 <8>	 8/15/93	JAY		add duplicate command to build
#		 <7>	 8/15/93	JAY		add modbin to build
#		 <6>	 6/24/93	dsm		Add increased stacksize -w 4096 to linker options
#		 <5>	 6/14/93	JAY		add stack checking option (-zps0) to COptions. Required for
#									Dragon Release (4B1).
#		 <4>	  4/7/93	JAY		make the make file consistant
#		 <3>	  4/3/93	JAY		add LIBS to link dependency
#		 <2>	 3/31/93	JAY		adding input.lib to link line for 3B1
#		 <1>	 3/18/93	JAY		first checked in
#
#	To Do:
#

#####################################
#		Symbol definitions
#####################################
Application		=	Bounce
DebugFlag		=	0
ObjectDir		=	:Objects:
CC				=	armcc
ASM				=	armasm
LINK			=	armlink


#####################################
#	Default compiler options
#####################################
CDebugOptions	= -g
COptions		= {CDebugOptions} -zps0 -za1 -i "{3DOIncludes}" -d DEBUG={DebugFlag}

SOptions		= -bi -g -i "{3DOIncludes}"

LDebugOptions	= -d 
LOptions		= -aif -r -b 0x00 -workspace 4096 {LDebugOptions}


#####################################
#		Object files
#####################################
LIBS			=	"{3DOLibs}Lib3DO.lib"		
					"{3DOLibs}operamath.lib"	
					"{3DOLibs}graphics.lib"	
					"{3DOLibs}audio.lib"		
					"{3DOLibs}filesystem.lib"		
					"{3DOLibs}input.lib"		
					"{3DOLibs}clib.lib"		
					"{3DOLibs}swi.lib"

# NOTE: Add object files here...
OBJECTS			=	"{ObjectDir}{Application}.c.o"

#####################################
#	Default build rules
#####################################
All					{Application}

{ObjectDir}			:

.c.o				.c
	{CC} {COptions} -o {TargDir}{Default}.c.o {DepDir}{Default}.c

.s.o				.s
	{ASM} {SOptions} -o {TargDir}{Default}.s.o {DepDir}{Default}.s


#####################################
#	Target build rules
#####################################
{Application}			{Application}.make {LIBS} {OBJECTS}
	{LINK}	{LOptions}					
			-o {Application}				
			"{3DOLibs}cstartup.o"		
			{OBJECTS}					
			{LIBS}
	SetFile {Application} -c 'EaDJ' -t 'PROJ'
	modbin {Application} -stack 4096
	stripaif "{Application}" -o "{Application}"
	duplicate "{Application}" "{Application}".sym "{3DORemote}" {3DOAutodup}


#####################################
#	Include file dependencies
#####################################
#{Application}.c			{Application}.h 
